org.apache.catalina.startup

## Class FailedContext

- java.lang.Object
- - org.apache.catalina.util.LifecycleBase
  - - org.apache.catalina.util.LifecycleMBeanBase
    - - org.apache.catalina.startup.FailedContext

- All Implemented Interfaces:
    MBeanRegistration, Container, Context, Lifecycle

      public class FailedContext
      extends LifecycleMBeanBase
      implements Context

  An implementation of `Context` that is used as a place-holder for deployed applications when their deployment fails and a Context instance (usually `StandardContext` but may be any Context implementation) cannot be created.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.catalina.Lifecycle

      `Lifecycle.SingleUse`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static StringManager` | `sm`

    - ### Fields inherited from class org.apache.catalina.util.LifecycleMBeanBase

      `mserver`

    - ### Fields inherited from interface org.apache.catalina.Context

      `ADD_WELCOME_FILE_EVENT, CHANGE_SESSION_ID_EVENT, CLEAR_WELCOME_FILES_EVENT, RELOAD_EVENT, REMOVE_WELCOME_FILE_EVENT`

    - ### Fields inherited from interface org.apache.catalina.Container

      `ADD_CHILD_EVENT, ADD_MAPPER_EVENT, ADD_VALVE_EVENT, REMOVE_CHILD_EVENT, REMOVE_MAPPER_EVENT, REMOVE_VALVE_EVENT`

    - ### Fields inherited from interface org.apache.catalina.Lifecycle

      `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FailedContext()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addApplicationListener(ApplicationListener listener)` Add a new Listener class name to the set of Listeners configured for this application.
    `void` | `addApplicationListener(String listener)` Add a new Listener class name to the set of Listeners configured for this application.
    `void` | `addApplicationParameter(ApplicationParameter parameter)` Add a new application parameter for this application.
    `void` | `addChild(Container child)` Add a new child Container to those associated with this Container, if supported.
    `void` | `addConstraint(SecurityConstraint constraint)` Add a security constraint to the set for this web application.
    `void` | `addContainerListener(ContainerListener listener)` Add a container event listener to this component.
    `void` | `addErrorPage(ErrorPage errorPage)` Add an error page for the specified error or Java exception.
    `void` | `addFilterDef(FilterDef filterDef)` Add a filter definition to this Context.
    `void` | `addFilterMap(FilterMap filterMap)` Add a filter mapping to this Context.
    `void` | `addFilterMapBefore(FilterMap filterMap)` Add a filter mapping to this Context before the mappings defined in the deployment descriptor but after any other mappings added via this method.
    `void` | `addInstanceListener(String listener)` Add the classname of an InstanceListener to be added to each Wrapper appended to this Context.
    `void` | `addLocaleEncodingMappingParameter(String locale, String encoding)` Add a Locale Encoding Mapping (see Sec 5.4 of Servlet spec 2.4)
    `void` | `addMimeMapping(String extension, String mimeType)` Add a new MIME mapping, replacing any existing mapping for the specified extension.
    `void` | `addParameter(String name, String value)` Add a new context initialization parameter, replacing any existing value for the specified name.
    `void` | `addPostConstructMethod(String clazz, String method)` Add a post construct method definition for the given class, if there is an existing definition for the specified class - IllegalArgumentException will be thrown.
    `void` | `addPreDestroyMethod(String clazz, String method)` Add a pre destroy method definition for the given class, if there is an existing definition for the specified class - IllegalArgumentException will be thrown.
    `void` | `addPropertyChangeListener(PropertyChangeListener listener)` Add a property change listener to this component.
    `void` | `addResourceJarUrl(URL url)` Add a URL for a JAR that contains static resources in a META-INF/resources directory that should be included in the static resources for this context.
    `void` | `addRoleMapping(String role, String link)` Add a security role reference for this web application.
    `void` | `addSecurityRole(String role)` Add a new security role for this web application.
    `void` | `addServletContainerInitializer(ServletContainerInitializer sci, Set<Class<?>> classes)` Add a ServletContainerInitializer instance to this web application.
    `void` | `addServletMapping(String pattern, String name)` Add a new servlet mapping, replacing any existing mapping for the specified pattern.
    `void` | `addServletMapping(String pattern, String name, boolean jspWildcard)` Add a new servlet mapping, replacing any existing mapping for the specified pattern.
    `Set<String>` | `addServletSecurity(ApplicationServletRegistration registration, ServletSecurityElement servletSecurityElement)` Notification that servlet security has been dynamically set in a `ServletRegistration.Dynamic`
    `void` | `addValve(Valve valve)`
    `void` | `addWatchedResource(String name)` Add a resource which will be watched for reloading by the host auto deployer.
    `void` | `addWelcomeFile(String name)` Add a new welcome file to the set recognized by this Context.
    `void` | `addWrapperLifecycle(String listener)` Add the classname of a LifecycleListener to be added to each Wrapper appended to this Context.
    `void` | `addWrapperListener(String listener)` Add the classname of a ContainerListener to be added to each Wrapper appended to this Context.
    `void` | `backgroundProcess()` Execute a periodic task, such as reloading, etc.
    `Wrapper` | `createWrapper()` Factory method to create and return a new Wrapper instance, of the Java implementation class appropriate for this Context implementation.
    `String[]` | `findApplicationListeners()` Return the set of application listener class names configured for this application.
    `ApplicationParameter[]` | `findApplicationParameters()` Return the set of application parameters for this application.
    `Container` | `findChild(String name)` Return the child Container, associated with this Container, with the specified name (if any); otherwise, return `null`
    `Container[]` | `findChildren()` Return the set of children Containers associated with this Container.
    `SecurityConstraint[]` | `findConstraints()` Return the set of security constraints for this web application.
    `ContainerListener[]` | `findContainerListeners()` Return the set of container listeners associated with this Container.
    `ErrorPage` | `findErrorPage(int errorCode)` Return the error page entry for the specified HTTP error code, if any; otherwise return `null`.
    `ErrorPage` | `findErrorPage(String exceptionType)` Return the error page entry for the specified Java exception type, if any; otherwise return `null`.
    `ErrorPage[]` | `findErrorPages()` Return the set of defined error pages for all specified error codes and exception types.
    `FilterDef` | `findFilterDef(String filterName)` Return the filter definition for the specified filter name, if any; otherwise return `null`.
    `FilterDef[]` | `findFilterDefs()` Return the set of defined filters for this Context.
    `FilterMap[]` | `findFilterMaps()` Return the set of filter mappings for this Context.
    `String[]` | `findInstanceListeners()` Return the set of InstanceListener classes that will be added to newly created Wrappers automatically.
    `String` | `findMimeMapping(String extension)` Return the MIME type to which the specified extension is mapped, if any; otherwise return `null`.
    `String[]` | `findMimeMappings()` Return the extensions for which MIME mappings are defined.
    `String` | `findParameter(String name)` Return the value for the specified context initialization parameter name, if any; otherwise return `null`.
    `String[]` | `findParameters()` Return the names of all defined context initialization parameters for this Context.
    `String` | `findPostConstructMethod(String clazz)` Returns the method name that is specified as post construct method for the given class, if it exists; otherwise `NULL` will be returned.
    `Map<String,String>` | `findPostConstructMethods()` Returns a map with keys - fully qualified class names of the classes that have post construct methods and the values are the corresponding method names.
    `String` | `findPreDestroyMethod(String clazz)` Returns the method name that is specified as pre destroy method for the given class, if it exists; otherwise `NULL` will be returned.
    `Map<String,String>` | `findPreDestroyMethods()` Returns a map with keys - fully qualified class names of the classes that have pre destroy methods and the values are the corresponding method names.
    `String` | `findRoleMapping(String role)` For the given security role (as used by an application), return the corresponding role name (as defined by the underlying Realm) if there is one.
    `boolean` | `findSecurityRole(String role)` Return `true` if the specified security role is defined for this application; otherwise return `false`.
    `String[]` | `findSecurityRoles()` Return the security roles defined for this application.
    `String` | `findServletMapping(String pattern)` Return the servlet name mapped by the specified pattern (if any); otherwise return `null`.
    `String[]` | `findServletMappings()` Return the patterns of all defined servlet mappings for this Context.
    `String` | `findStatusPage(int status)` Return the context-relative URI of the error page for the specified HTTP status code, if any; otherwise return `null`.
    `int[]` | `findStatusPages()` Return the set of HTTP status codes for which error pages have been specified.
    `String[]` | `findWatchedResources()` Return the set of watched resources for this Context.
    `boolean` | `findWelcomeFile(String name)` Return `true` if the specified welcome file is defined for this Context; otherwise return `false`.
    `String[]` | `findWelcomeFiles()` Return the set of welcome files defined for this Context.
    `String[]` | `findWrapperLifecycles()` Return the set of LifecycleListener classes that will be added to newly created Wrappers automatically.
    `String[]` | `findWrapperListeners()` Return the set of ContainerListener classes that will be added to newly created Wrappers automatically.
    `void` | `fireContainerEvent(String type, Object data)` Notify all container event listeners that a particular event has occurred for this Container.
    `boolean` | `fireRequestDestroyEvent(ServletRequest request)` Notify all `ServletRequestListener`s that a request has ended.
    `boolean` | `fireRequestInitEvent(ServletRequest request)` Notify all `ServletRequestListener`s that a request has started.
    `AccessLog` | `getAccessLog()` Identify the AccessLog to use to log a request/response that was destined for this container but was handled earlier in the processing chain so that the request/response still appears in the correct access logs.
    `boolean` | `getAllowCasualMultipartParsing()` Returns `true` if requests mapped to servlets without "multipart config" to parse multipart/form-data requests anyway.
    `String` | `getAltDDName()` Return the alternate Deployment Descriptor name.
    `Object[]` | `getApplicationEventListeners()` Return the set of initialized application event listener objects, in the order they were specified in the web application deployment descriptor, for this application.
    `Object[]` | `getApplicationLifecycleListeners()` Return the set of initialized application lifecycle listener objects, in the order they were specified in the web application deployment descriptor, for this application.
    `Authenticator` | `getAuthenticator()` Obtain the `Authenticator` that is used by this context or `null` if none is used.
    `boolean` | `getAvailable()` Return the application available flag for this Context.
    `int` | `getBackgroundProcessorDelay()` Get the delay between the invocation of the backgroundProcess method on this container and its children.
    `String` | `getBaseName()` Return the base name to use for WARs, directories or context.xml files for this context.
    `String` | `getCharset(Locale locale)` Obtain the character set name to use with the given Locale.
    `CharsetMapper` | `getCharsetMapper()` Deprecated.
    `Cluster` | `getCluster()` Return the Cluster with which this Container is associated.
    `URL` | `getConfigFile()` Return the URL of the XML descriptor for this context.
    `boolean` | `getConfigured()` Return the "correctly configured" flag for this Context.
    `String` | `getContainerSciFilter()` Obtains the regular expression that specifies which container provided SCIs should be filtered out and not used for this context.
    `boolean` | `getCookies()` Return the "use cookies for session ids" flag.
    `boolean` | `getCrossContext()` Return the "allow crossing servlet contexts" flag.
    `String` | `getDisplayName()` Return the display name of this web application.
    `boolean` | `getDistributable()` Return the distributable flag for this web application.
    `String` | `getDocBase()` Return the document root for this Context.
    `protected String` | `getDomainInternal()` Deprecated.
    `int` | `getEffectiveMajorVersion()` Return the effective major version of the Servlet spec used by this context.
    `int` | `getEffectiveMinorVersion()` Return the effective minor version of the Servlet spec used by this context.
    `String` | `getEncodedPath()` Return the URL encoded context path, using UTF-8.
    `boolean` | `getFireRequestListenersOnForwards()` Determine whether or not requests listeners will be fired on forwards for this Context.
    `boolean` | `getIgnoreAnnotations()` Return the boolean on the annotations parsing.
    `String` | `getInfo()` Return descriptive information about this Container implementation and the corresponding version number, in the format `<description>/<version>`.
    `InstanceManager` | `getInstanceManager()` Get the instance manager associated with this context.
    `JarScanner` | `getJarScanner()` Get the Jar Scanner to be used to scan for JAR resources for this context.
    `JspConfigDescriptor` | `getJspConfigDescriptor()` Obtain the JSP configuration for this context.
    `Loader` | `getLoader()` Return the Loader with which this Container is associated.
    `boolean` | `getLogEffectiveWebXml()` Should the effective web.xml for this context be logged on context start?
    `Log` | `getLogger()` Return the Logger with which this Container is associated.
    `LoginConfig` | `getLoginConfig()` Return the login configuration descriptor for this web application.
    `Manager` | `getManager()` Return the Manager with which this Container is associated.
    `Mapper` | `getMapper()` Get the request dispatcher mapper.
    `boolean` | `getMapperContextRootRedirectEnabled()` Determines if requests for a web application context root will be redirected (adding a trailing slash) by the Mapper.
    `boolean` | `getMapperDirectoryRedirectEnabled()` Determines if requests for a directory will be redirected (adding a trailing slash) by the Mapper.
    `Object` | `getMappingObject()` Return an object which may be utilized for mapping to this component.
    `String` | `getName()` Return a name string (suitable for use by humans) that describes this Container.
    `NamingResources` | `getNamingResources()` Return the naming resources associated with this web application.
    `protected String` | `getObjectNameKeyProperties()` Allow sub-classes to specify the key properties component of the `ObjectName` that will be used to register this component.
    `boolean` | `getOverride()` Return the override flag for this web application.
    `Container` | `getParent()` Return the Container for which this Container is a child, if there is one.
    `ClassLoader` | `getParentClassLoader()` Return the parent class loader for this component.
    `String` | `getPath()` Return the context path for this web application.
    `boolean` | `getPaused()` Is this Context paused whilst it is reloaded?
    `Pipeline` | `getPipeline()` Return the Pipeline object that manages the Valves associated with this Container.
    `boolean` | `getPreemptiveAuthentication()` Determines if a user presents authentication credentials, will the context will process them when the request is for a non-protected resource.
    `boolean` | `getPrivileged()` Return the privileged flag for this web application.
    `String` | `getPublicId()` Return the public identifier of the deployment descriptor DTD that is currently being parsed.
    `Realm` | `getRealm()` Return the Realm with which this Container is associated.
    `String` | `getRealPath(String path)` Return the real path for a given virtual path, if possible; otherwise return `null`.
    `boolean` | `getReloadable()` Return the reloadable flag for this web application.
    `String` | `getResourceOnlyServlets()` Obtains the list of Servlets that expect a resource to be present.
    `DirContext` | `getResources()` Return the Resources with which this Container is associated.
    `boolean` | `getSendRedirectBody()` Determines if the context is configured to include a response body as part of a redirect response.
    `ServletContext` | `getServletContext()` Return the servlet context for which this Context is a facade.
    `String` | `getSessionCookieDomain()` Gets the domain to use for session cookies.
    `String` | `getSessionCookieName()` Gets the name to use for session cookies.
    `String` | `getSessionCookiePath()` Gets the path to use for session cookies.
    `boolean` | `getSessionCookiePathUsesTrailingSlash()` Is a / added to the end of the session cookie path to ensure browsers, particularly IE, don't send a session cookie for context /foo with requests intended for context /foobar.
    `int` | `getSessionTimeout()` Return the default session timeout (in minutes) for this web application.
    `int` | `getStartStopThreads()` Returns the number of threads available for starting and stopping any children associated with this container.
    `boolean` | `getSwallowAbortedUploads()` Returns `true` if remaining request data will be read (swallowed) even the request violates a data size constraint.
    `boolean` | `getSwallowOutput()` Return the value of the swallowOutput flag.
    `boolean` | `getTldNamespaceAware()` *.tld files are always parsed using a namespace aware parser.
    `boolean` | `getTldValidation()` Will the parsing of *.tld files for this Context be performed by a validating parser?
    `boolean` | `getUseHttpOnly()` Gets the value of the use HttpOnly cookies for session cookies flag.
    `boolean` | `getUseRelativeRedirects()` Will HTTP 1.1 and later location headers generated by a call to `HttpServletResponse.sendRedirect(String)` use relative or absolute redirects.
    `boolean` | `getValidateClientProvidedNewSessionId()` Will client provided session IDs be validated (see `Context.setValidateClientProvidedNewSessionId(boolean)`) before use?
    `String` | `getWebappVersion()` Set the version of this web application - used to differentiate different versions of the same web application when using parallel deployment.
    `String` | `getWrapperClass()` Return the Java class name of the Wrapper implementation used for servlets registered in this Context.
    `boolean` | `getXmlBlockExternal()` Will the parsing of web.xml, web-fragment.xml, *.tld, *.jspx, *.tagx and tagplugin.xml files for this Context block the use of external entities?
    `boolean` | `getXmlNamespaceAware()` Will the parsing of web.xml and web-fragment.xml files for this Context be performed by a namespace aware parser?
    `boolean` | `getXmlValidation()` Will the parsing of web.xml and web-fragment.xml files for this Context be performed by a validating parser?
    `void` | `invoke(Request request, Response response)` Process the specified Request, and generate the corresponding Response, according to the design of this particular Container.
    `boolean` | `isResourceOnlyServlet(String servletName)` Checks the named Servlet to see if it expects a resource to be present.
    `boolean` | `isServlet22()` Is this context using version 2.2 of the Servlet spec?
    `void` | `logAccess(Request request, Response response, long time, boolean useDefault)` Log a request/response that was destined for this container but has been handled earlier in the processing chain so that the request/response still appears in the correct access logs.
    `void` | `reload()` Reload this web application, if reloading is supported.
    `void` | `removeApplicationListener(String listener)` Remove the specified application listener class from the set of listeners for this application.
    `void` | `removeApplicationParameter(String name)` Remove the application parameter with the specified name from the set for this application.
    `void` | `removeChild(Container child)` Remove an existing child Container from association with this parent Container.
    `void` | `removeConstraint(SecurityConstraint constraint)` Remove the specified security constraint from this web application.
    `void` | `removeContainerListener(ContainerListener listener)` Remove a container event listener from this component.
    `void` | `removeErrorPage(ErrorPage errorPage)` Remove the error page for the specified error code or Java language exception, if it exists; otherwise, no action is taken.
    `void` | `removeFilterDef(FilterDef filterDef)` Remove the specified filter definition from this Context, if it exists; otherwise, no action is taken.
    `void` | `removeFilterMap(FilterMap filterMap)` Remove a filter mapping from this Context.
    `void` | `removeInstanceListener(String listener)` Remove a class name from the set of InstanceListener classes that will be added to newly created Wrappers.
    `void` | `removeMimeMapping(String extension)` Remove the MIME mapping for the specified extension, if it exists; otherwise, no action is taken.
    `void` | `removeParameter(String name)` Remove the context initialization parameter with the specified name, if it exists; otherwise, no action is taken.
    `void` | `removePostConstructMethod(String clazz)` Removes the post construct method definition for the given class, if it exists; otherwise, no action is taken.
    `void` | `removePreDestroyMethod(String clazz)` Removes the pre destroy method definition for the given class, if it exists; otherwise, no action is taken.
    `void` | `removePropertyChangeListener(PropertyChangeListener listener)` Remove a property change listener from this component.
    `void` | `removeRoleMapping(String role)` Remove any security role reference for the specified name
    `void` | `removeSecurityRole(String role)` Remove any security role with the specified name.
    `void` | `removeServletMapping(String pattern)` Remove any servlet mapping for the specified pattern, if it exists; otherwise, no action is taken.
    `void` | `removeWatchedResource(String name)` Remove the specified watched resource name from the list associated with this Context.
    `void` | `removeWelcomeFile(String name)` Remove the specified welcome file name from the list recognized by this Context.
    `void` | `removeWrapperLifecycle(String listener)` Remove a class name from the set of LifecycleListener classes that will be added to newly created Wrappers.
    `void` | `removeWrapperListener(String listener)` Remove a class name from the set of ContainerListener classes that will be added to newly created Wrappers.
    `void` | `setAllowCasualMultipartParsing(boolean allowCasualMultipartParsing)` Set to `true` to allow requests mapped to servlets that do not explicitly declare @MultipartConfig or have <multipart-config> specified in web.xml to parse multipart/form-data requests.
    `void` | `setAltDDName(String altDDName)` Set an alternate Deployment Descriptor name.
    `void` | `setApplicationEventListeners(Object[] listeners)` Store the set of initialized application event listener objects, in the order they were specified in the web application deployment descriptor, for this application.
    `void` | `setApplicationLifecycleListeners(Object[] listeners)` Store the set of initialized application lifecycle listener objects, in the order they were specified in the web application deployment descriptor, for this application.
    `void` | `setBackgroundProcessorDelay(int delay)` Set the delay between the invocation of the execute method on this container and its children.
    `void` | `setCharsetMapper(CharsetMapper mapper)` Deprecated.
    `void` | `setCluster(Cluster cluster)` Set the Cluster with which this Container is associated.
    `void` | `setConfigFile(URL configFile)` Set the URL of the XML descriptor for this context.
    `void` | `setConfigured(boolean configured)` Set the "correctly configured" flag for this Context.
    `void` | `setContainerSciFilter(String containerSciFilter)` Sets the regular expression that specifies which container provided SCIs should be filtered out and not used for this context.
    `void` | `setCookies(boolean cookies)` Set the "use cookies for session ids" flag.
    `void` | `setCrossContext(boolean crossContext)` Set the "allow crossing servlet contexts" flag.
    `void` | `setDisplayName(String displayName)` Set the display name of this web application.
    `void` | `setDistributable(boolean distributable)` Set the distributable flag for this web application.
    `void` | `setDocBase(String docBase)` Set the document root for this Context.
    `void` | `setEffectiveMajorVersion(int major)` Set the effective major version of the Servlet spec used by this context.
    `void` | `setEffectiveMinorVersion(int minor)` Set the effective minor version of the Servlet spec used by this context.
    `void` | `setFireRequestListenersOnForwards(boolean enable)` Configure whether or not requests listeners will be fired on forwards for this Context.
    `void` | `setIgnoreAnnotations(boolean ignoreAnnotations)` Set the boolean on the annotations parsing for this web application.
    `void` | `setInstanceManager(InstanceManager instanceManager)` Set the instance manager associated with this context.
    `void` | `setJarScanner(JarScanner jarScanner)` Set the Jar Scanner to be used to scan for JAR resources for this context.
    `void` | `setLoader(Loader loader)` Set the Loader with which this Container is associated.
    `void` | `setLogEffectiveWebXml(boolean logEffectiveWebXml)` Set whether or not the effective web.xml for this context should be logged on context start.
    `void` | `setLoginConfig(LoginConfig config)` Set the login configuration descriptor for this web application.
    `void` | `setManager(Manager manager)` Set the Manager with which this Container is associated.
    `void` | `setMapperContextRootRedirectEnabled(boolean mapperContextRootRedirectEnabled)` If enabled, requests for a web application context root will be redirected (adding a trailing slash) by the Mapper.
    `void` | `setMapperDirectoryRedirectEnabled(boolean mapperDirectoryRedirectEnabled)` If enabled, requests for a directory will be redirected (adding a trailing slash) by the Mapper.
    `void` | `setName(String name)` Set a name string (suitable for use by humans) that describes this Container.
    `void` | `setNamingResources(NamingResources namingResources)` Set the naming resources for this web application.
    `void` | `setOverride(boolean override)` Set the override flag for this web application.
    `void` | `setParent(Container parent)` Set the parent Container to which this Container is being added as a child.
    `void` | `setParentClassLoader(ClassLoader parent)` Set the parent class loader for this component.
    `void` | `setPath(String path)` Set the context path for this web application.
    `void` | `setPreemptiveAuthentication(boolean enable)` Configures if a user presents authentication credentials, whether the context will process them when the request is for a non-protected resource.
    `void` | `setPrivileged(boolean privileged)` Set the privileged flag for this web application.
    `void` | `setPublicId(String publicId)` Set the public identifier of the deployment descriptor DTD that is currently being parsed.
    `void` | `setRealm(Realm realm)` Set the Realm with which this Container is associated.
    `void` | `setReloadable(boolean reloadable)` Set the reloadable flag for this web application.
    `void` | `setResourceOnlyServlets(String resourceOnlyServlets)` Sets the (comma separated) list of Servlets that expect a resource to be present.
    `void` | `setResources(DirContext resources)` Set the Resources object with which this Container is associated.
    `void` | `setSendRedirectBody(boolean enable)` Configures if a response body is included when a redirect response is sent to the client.
    `void` | `setSessionCookieDomain(String sessionCookieDomain)` Sets the domain to use for session cookies.
    `void` | `setSessionCookieName(String sessionCookieName)` Sets the name to use for session cookies.
    `void` | `setSessionCookiePath(String sessionCookiePath)` Sets the path to use for session cookies.
    `void` | `setSessionCookiePathUsesTrailingSlash(boolean sessionCookiePathUsesTrailingSlash)` Configures if a / is added to the end of the session cookie path to ensure browsers, particularly IE, don't send a session cookie for context /foo with requests intended for context /foobar.
    `void` | `setSessionTimeout(int timeout)` Set the default session timeout (in minutes) for this web application.
    `void` | `setStartStopThreads(int startStopThreads)` Sets the number of threads available for starting and stopping any children associated with this container.
    `void` | `setSwallowAbortedUploads(boolean swallowAbortedUploads)` Set to `false` to disable request data swallowing after an upload was aborted due to size constraints.
    `void` | `setSwallowOutput(boolean swallowOutput)` Set the value of the swallowOutput flag.
    `void` | `setTldNamespaceAware(boolean tldNamespaceAware)` *.tld files are always parsed using a namespace aware parser.
    `void` | `setTldValidation(boolean tldValidation)` Controls whether the parsing of *.tld files for this Context will be performed by a validating parser.
    `void` | `setUseHttpOnly(boolean useHttpOnly)` Sets the use HttpOnly cookies for session cookies flag.
    `void` | `setUseRelativeRedirects(boolean useRelativeRedirects)` Controls whether HTTP 1.1 and later location headers generated by a call to `HttpServletResponse.sendRedirect(String)` will use relative or absolute redirects.
    `void` | `setValidateClientProvidedNewSessionId(boolean validateClientProvidedNewSessionId)` When a client provides the ID for a new session, should that ID be validated?
    `void` | `setWebappVersion(String webappVersion)` Set the version of this web application - used to differentiate different versions of the same web application when using parallel deployment.
    `void` | `setWrapperClass(String wrapperClass)` Set the Java class name of the Wrapper implementation used for servlets registered in this Context.
    `void` | `setXmlBlockExternal(boolean xmlBlockExternal)` Controls whether the parsing of web.xml, web-fragment.xml, *.tld, *.jspx, *.tagx and tagplugin.xml files for this Context will block the use of external entities.
    `void` | `setXmlNamespaceAware(boolean xmlNamespaceAware)` Controls whether the parsing of web.xml and web-fragment.xml files for this Context will be performed by a namespace aware parser.
    `void` | `setXmlValidation(boolean xmlValidation)` Controls whether the parsing of web.xml and web-fragment.xml files for this Context will be performed by a validating parser.
    `protected void` | `startInternal()` Sub-classes must ensure that the state is changed to `LifecycleState.STARTING` during the execution of this method.
    `protected void` | `stopInternal()` Sub-classes must ensure that the state is changed to `LifecycleState.STOPPING` during the execution of this method.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.catalina.util.LifecycleMBeanBase

      `destroyInternal, getDomain, getObjectName, initInternal, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister`

    - ### Methods inherited from class org.apache.catalina.util.LifecycleBase

      `addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, init, removeLifecycleListener, setState, setState, start, stop`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.catalina.Container

      `getObjectName`

    - ### Methods inherited from interface org.apache.catalina.Lifecycle

      `addLifecycleListener, destroy, findLifecycleListeners, getState, getStateName, init, removeLifecycleListener, start, stop`

- - ### Field Detail

    - #### sm

          protected static final StringManager sm

  - ### Constructor Detail

    - #### FailedContext

          public FailedContext()

  - ### Method Detail

    - #### getConfigFile

          public URL getConfigFile()

      Description copied from interface: `Context`
      Return the URL of the XML descriptor for this context.
      Specified by:
        `getConfigFile` in interface `Context`

    - #### setConfigFile

          public void setConfigFile(URL configFile)

      Description copied from interface: `Context`
      Set the URL of the XML descriptor for this context.
      Specified by:
        `setConfigFile` in interface `Context`
      Parameters:
        `configFile` - The URL of the XML descriptor for this context.

    - #### getDocBase

          public String getDocBase()

      Description copied from interface: `Context`
      Return the document root for this Context. This can be an absolute pathname, a relative pathname, or a URL.
      Specified by:
        `getDocBase` in interface `Context`

    - #### setDocBase

          public void setDocBase(String docBase)

      Description copied from interface: `Context`
      Set the document root for this Context. This can be an absolute pathname, a relative pathname, or a URL.
      Specified by:
        `setDocBase` in interface `Context`
      Parameters:
        `docBase` - The new document root

    - #### getName

          public String getName()

      Description copied from interface: `Container`
      Return a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.
      Specified by:
        `getName` in interface `Container`

    - #### setName

          public void setName(String name)

      Description copied from interface: `Container`
      Set a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.
      Specified by:
        `setName` in interface `Container`
      Parameters:
        `name` - New name of this container

    - #### getParent

          public Container getParent()

      Description copied from interface: `Container`
      Return the Container for which this Container is a child, if there is one. If there is no defined parent, return `null`.
      Specified by:
        `getParent` in interface `Container`

    - #### setParent

          public void setParent(Container parent)

      Description copied from interface: `Container`
      Set the parent Container to which this Container is being added as a child. This Container may refuse to become attached to the specified Container by throwing an exception.
      Specified by:
        `setParent` in interface `Container`
      Parameters:
        `parent` - Container to which this Container is being added as a child

    - #### getPath

          public String getPath()

      Description copied from interface: `Context`
      Return the context path for this web application.
      Specified by:
        `getPath` in interface `Context`

    - #### setPath

          public void setPath(String path)

      Description copied from interface: `Context`
      Set the context path for this web application.
      Specified by:
        `setPath` in interface `Context`
      Parameters:
        `path` - The new context path

    - #### getWebappVersion

          public String getWebappVersion()

      Description copied from interface: `Context`
      Set the version of this web application - used to differentiate different versions of the same web application when using parallel deployment. If not specified, defaults to the empty string.
      Specified by:
        `getWebappVersion` in interface `Context`

    - #### setWebappVersion

          public void setWebappVersion(String webappVersion)

      Description copied from interface: `Context`
      Set the version of this web application - used to differentiate different versions of the same web application when using parallel deployment.
      Specified by:
        `setWebappVersion` in interface `Context`

    - #### getDomainInternal

          @Deprecated
          protected String getDomainInternal()

      Deprecated.
      Description copied from class: `LifecycleMBeanBase`
      Method implemented by sub-classes to identify the domain in which MBeans should be registered.
      Specified by:
        `getDomainInternal` in class `LifecycleMBeanBase`
      Returns:
        The name of the domain to use to register MBeans.

    - #### getObjectNameKeyProperties

          protected String getObjectNameKeyProperties()

      Description copied from class: `LifecycleMBeanBase`
      Allow sub-classes to specify the key properties component of the `ObjectName` that will be used to register this component.
      Specified by:
        `getObjectNameKeyProperties` in class `LifecycleMBeanBase`
      Returns:
        The string representation of the key properties component of the desired `ObjectName`

    - #### startInternal

          protected void startInternal()
                                throws LifecycleException

      Description copied from class: `LifecycleBase`
      Sub-classes must ensure that the state is changed to `LifecycleState.STARTING` during the execution of this method. Changing state will trigger the `Lifecycle.START_EVENT` event. If a component fails to start it may either throw a `LifecycleException` which will cause it's parent to fail to start or it can place itself in the error state in which case `LifecycleBase.stop()` will be called on the failed component but the parent component will continue to start normally.
      Specified by:
        `startInternal` in class `LifecycleBase`
      Throws:
        `LifecycleException`

    - #### stopInternal

          protected void stopInternal()
                               throws LifecycleException

      Description copied from class: `LifecycleBase`
      Sub-classes must ensure that the state is changed to `LifecycleState.STOPPING` during the execution of this method. Changing state will trigger the `Lifecycle.STOP_EVENT` event.
      Specified by:
        `stopInternal` in class `LifecycleBase`
      Throws:
        `LifecycleException`

    - #### addWatchedResource

          public void addWatchedResource(String name)

      Description copied from interface: `Context`
      Add a resource which will be watched for reloading by the host auto deployer. Note: this will not be used in embedded mode.
      Specified by:
        `addWatchedResource` in interface `Context`
      Parameters:
        `name` - Path to the resource, relative to docBase

    - #### findWatchedResources

          public String[] findWatchedResources()

      Description copied from interface: `Context`
      Return the set of watched resources for this Context. If none are defined, a zero length array will be returned.
      Specified by:
        `findWatchedResources` in interface `Context`

    - #### removeWatchedResource

          public void removeWatchedResource(String name)

      Description copied from interface: `Context`
      Remove the specified watched resource name from the list associated with this Context.
      Specified by:
        `removeWatchedResource` in interface `Context`
      Parameters:
        `name` - Name of the watched resource to be removed

    - #### addChild

          public void addChild(Container child)

      Description copied from interface: `Container`
      Add a new child Container to those associated with this Container, if supported. Prior to adding this Container to the set of children, the child's `setParent()` method must be called, with this Container as an argument. This method may thrown an `IllegalArgumentException` if this Container chooses not to be attached to the specified Container, in which case it is not added
      Specified by:
        `addChild` in interface `Container`
      Parameters:
        `child` - New child Container to be added

    - #### findChild

          public Container findChild(String name)

      Description copied from interface: `Container`
      Return the child Container, associated with this Container, with the specified name (if any); otherwise, return `null`
      Specified by:
        `findChild` in interface `Container`
      Parameters:
        `name` - Name of the child Container to be retrieved

    - #### findChildren

          public Container[] findChildren()

      Description copied from interface: `Container`
      Return the set of children Containers associated with this Container. If this Container has no children, a zero-length array is returned.
      Specified by:
        `findChildren` in interface `Container`

    - #### removeChild

          public void removeChild(Container child)

      Description copied from interface: `Container`
      Remove an existing child Container from association with this parent Container.
      Specified by:
        `removeChild` in interface `Container`
      Parameters:
        `child` - Existing child Container to be removed

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getLoader

          public Loader getLoader()

      Description copied from interface: `Container`
      Return the Loader with which this Container is associated. If there is no associated Loader, return the Loader associated with our parent Container (if any); otherwise, return `null`.
      Specified by:
        `getLoader` in interface `Container`

    - #### setLoader

          public void setLoader(Loader loader)

      Description copied from interface: `Container`
      Set the Loader with which this Container is associated.
      Specified by:
        `setLoader` in interface `Container`
      Parameters:
        `loader` - The newly associated loader

    - #### getLogger

          public Log getLogger()

      Description copied from interface: `Container`
      Return the Logger with which this Container is associated. If there is no associated Logger, return the Logger associated with our parent Container (if any); otherwise return `null`.
      Specified by:
        `getLogger` in interface `Container`

    - #### getManager

          public Manager getManager()

      Description copied from interface: `Container`
      Return the Manager with which this Container is associated. If there is no associated Manager, return the Manager associated with our parent Container (if any); otherwise return `null`.
      Specified by:
        `getManager` in interface `Container`

    - #### setManager

          public void setManager(Manager manager)

      Description copied from interface: `Container`
      Set the Manager with which this Container is associated.
      Specified by:
        `setManager` in interface `Container`
      Parameters:
        `manager` - The newly associated Manager

    - #### getPipeline

          public Pipeline getPipeline()

      Description copied from interface: `Container`
      Return the Pipeline object that manages the Valves associated with this Container.
      Specified by:
        `getPipeline` in interface `Container`

    - #### getCluster

          public Cluster getCluster()

      Description copied from interface: `Container`
      Return the Cluster with which this Container is associated. If there is no associated Cluster, return the Cluster associated with our parent Container (if any); otherwise return `null`.
      Specified by:
        `getCluster` in interface `Container`

    - #### setCluster

          public void setCluster(Cluster cluster)

      Description copied from interface: `Container`
      Set the Cluster with which this Container is associated.
      Specified by:
        `setCluster` in interface `Container`
      Parameters:
        `cluster` - the Cluster with which this Container is associated.

    - #### getBackgroundProcessorDelay

          public int getBackgroundProcessorDelay()

      Description copied from interface: `Container`
      Get the delay between the invocation of the backgroundProcess method on this container and its children. Child containers will not be invoked if their delay value is not negative (which would mean they are using their own thread). Setting this to a positive value will cause a thread to be spawn. After waiting the specified amount of time, the thread will invoke the executePeriodic method on this container and all its children.
      Specified by:
        `getBackgroundProcessorDelay` in interface `Container`

    - #### setBackgroundProcessorDelay

          public void setBackgroundProcessorDelay(int delay)

      Description copied from interface: `Container`
      Set the delay between the invocation of the execute method on this container and its children.
      Specified by:
        `setBackgroundProcessorDelay` in interface `Container`
      Parameters:
        `delay` - The delay in seconds between the invocation of backgroundProcess methods

    - #### getParentClassLoader

          public ClassLoader getParentClassLoader()

      Description copied from interface: `Container`
      Return the parent class loader for this component. If not set, return `Container.getParent()` `Container.getParentClassLoader()`. If no parent has been set, return the system class loader.
      Specified by:
        `getParentClassLoader` in interface `Container`

    - #### setParentClassLoader

          public void setParentClassLoader(ClassLoader parent)

      Description copied from interface: `Container`
      Set the parent class loader for this component. For `Context`s this call is meaningful only before a Loader has been configured, and the specified value (if non-null) should be passed as an argument to the class loader constructor.
      Specified by:
        `setParentClassLoader` in interface `Container`
      Parameters:
        `parent` - The new parent class loader

    - #### getRealm

          public Realm getRealm()

      Description copied from interface: `Container`
      Return the Realm with which this Container is associated. If there is no associated Realm, return the Realm associated with our parent Container (if any); otherwise return `null`.
      Specified by:
        `getRealm` in interface `Container`

    - #### setRealm

          public void setRealm(Realm realm)

      Description copied from interface: `Container`
      Set the Realm with which this Container is associated.
      Specified by:
        `setRealm` in interface `Container`
      Parameters:
        `realm` - The newly associated Realm

    - #### getResources

          public DirContext getResources()

      Description copied from interface: `Container`
      Return the Resources with which this Container is associated. If there is no associated Resources object, return the Resources associated with our parent Container (if any); otherwise return `null`.
      Specified by:
        `getResources` in interface `Container`

    - #### setResources

          public void setResources(DirContext resources)

      Description copied from interface: `Container`
      Set the Resources object with which this Container is associated.
      Specified by:
        `setResources` in interface `Container`
      Parameters:
        `resources` - The newly associated Resources

    - #### backgroundProcess

          public void backgroundProcess()

      Description copied from interface: `Container`
      Execute a periodic task, such as reloading, etc. This method will be invoked inside the classloading context of this container. Unexpected throwables will be caught and logged.
      Specified by:
        `backgroundProcess` in interface `Container`

    - #### addContainerListener

          public void addContainerListener(ContainerListener listener)

      Description copied from interface: `Container`
      Add a container event listener to this component.
      Specified by:
        `addContainerListener` in interface `Container`
      Parameters:
        `listener` - The listener to add

    - #### findContainerListeners

          public ContainerListener[] findContainerListeners()

      Description copied from interface: `Container`
      Return the set of container listeners associated with this Container. If this Container has no registered container listeners, a zero-length array is returned.
      Specified by:
        `findContainerListeners` in interface `Container`

    - #### removeContainerListener

          public void removeContainerListener(ContainerListener listener)

      Description copied from interface: `Container`
      Remove a container event listener from this component.
      Specified by:
        `removeContainerListener` in interface `Container`
      Parameters:
        `listener` - The listener to remove

    - #### addPropertyChangeListener

          public void addPropertyChangeListener(PropertyChangeListener listener)

      Description copied from interface: `Container`
      Add a property change listener to this component.
      Specified by:
        `addPropertyChangeListener` in interface `Container`
      Parameters:
        `listener` - The listener to add

    - #### removePropertyChangeListener

          public void removePropertyChangeListener(PropertyChangeListener listener)

      Description copied from interface: `Container`
      Remove a property change listener from this component.
      Specified by:
        `removePropertyChangeListener` in interface `Container`
      Parameters:
        `listener` - The listener to remove

    - #### invoke

          public void invoke(Request request,
                    Response response)
                      throws IOException,
                             ServletException

      Description copied from interface: `Container`
      Process the specified Request, and generate the corresponding Response, according to the design of this particular Container.
      Specified by:
        `invoke` in interface `Container`
      Parameters:
        `request` - Request to be processed
        `response` - Response to be produced
      Throws:
        `IOException` - if an input/output error occurred while processing
        `ServletException` - if a ServletException was thrown while processing this request

    - #### fireContainerEvent

          public void fireContainerEvent(String type,
                                Object data)

      Description copied from interface: `Container`
      Notify all container event listeners that a particular event has occurred for this Container. The default implementation performs this notification synchronously using the calling thread.
      Specified by:
        `fireContainerEvent` in interface `Container`
      Parameters:
        `type` - Event type
        `data` - Event data

    - #### logAccess

          public void logAccess(Request request,
                       Response response,
                       long time,
                       boolean useDefault)

      Description copied from interface: `Container`
      Log a request/response that was destined for this container but has been handled earlier in the processing chain so that the request/response still appears in the correct access logs.
      Specified by:
        `logAccess` in interface `Container`
      Parameters:
        `request` - Request (associated with the response) to log
        `response` - Response (associated with the request) to log
        `time` - Time taken to process the request/response in milliseconds (use 0 if not known)
        `useDefault` - Flag that indicates that the request/response should be logged in the engine's default access log

    - #### getAccessLog

          public AccessLog getAccessLog()

      Description copied from interface: `Container`
      Identify the AccessLog to use to log a request/response that was destined for this container but was handled earlier in the processing chain so that the request/response still appears in the correct access logs.
      Specified by:
        `getAccessLog` in interface `Container`

    - #### getStartStopThreads

          public int getStartStopThreads()

      Description copied from interface: `Container`
      Returns the number of threads available for starting and stopping any children associated with this container. This allows start/stop calls to children to be processed in parallel.
      Specified by:
        `getStartStopThreads` in interface `Container`

    - #### setStartStopThreads

          public void setStartStopThreads(int startStopThreads)

      Description copied from interface: `Container`
      Sets the number of threads available for starting and stopping any children associated with this container. This allows start/stop calls to children to be processed in parallel.
      Specified by:
        `setStartStopThreads` in interface `Container`
      Parameters:
        `startStopThreads` - The new number of threads to be used

    - #### getAllowCasualMultipartParsing

          public boolean getAllowCasualMultipartParsing()

      Description copied from interface: `Context`
      Returns `true` if requests mapped to servlets without "multipart config" to parse multipart/form-data requests anyway.
      Specified by:
        `getAllowCasualMultipartParsing` in interface `Context`
      Returns:
        `true` if requests mapped to servlets without "multipart config" to parse multipart/form-data requests, `false` otherwise.

    - #### setAllowCasualMultipartParsing

          public void setAllowCasualMultipartParsing(boolean allowCasualMultipartParsing)

      Description copied from interface: `Context`
      Set to `true` to allow requests mapped to servlets that do not explicitly declare @MultipartConfig or have <multipart-config> specified in web.xml to parse multipart/form-data requests.
      Specified by:
        `setAllowCasualMultipartParsing` in interface `Context`
      Parameters:
        `allowCasualMultipartParsing` - `true` to allow such casual parsing, `false` otherwise.

    - #### getApplicationEventListeners

          public Object[] getApplicationEventListeners()

      Description copied from interface: `Context`
      Return the set of initialized application event listener objects, in the order they were specified in the web application deployment descriptor, for this application.
      Specified by:
        `getApplicationEventListeners` in interface `Context`

    - #### setApplicationEventListeners

          public void setApplicationEventListeners(Object[] listeners)

      Description copied from interface: `Context`
      Store the set of initialized application event listener objects, in the order they were specified in the web application deployment descriptor, for this application.
      Specified by:
        `setApplicationEventListeners` in interface `Context`
      Parameters:
        `listeners` - The set of instantiated listener objects.

    - #### getApplicationLifecycleListeners

          public Object[] getApplicationLifecycleListeners()

      Description copied from interface: `Context`
      Return the set of initialized application lifecycle listener objects, in the order they were specified in the web application deployment descriptor, for this application.
      Specified by:
        `getApplicationLifecycleListeners` in interface `Context`

    - #### setApplicationLifecycleListeners

          public void setApplicationLifecycleListeners(Object[] listeners)

      Description copied from interface: `Context`
      Store the set of initialized application lifecycle listener objects, in the order they were specified in the web application deployment descriptor, for this application.
      Specified by:
        `setApplicationLifecycleListeners` in interface `Context`
      Parameters:
        `listeners` - The set of instantiated listener objects.

    - #### getAvailable

          public boolean getAvailable()

      Description copied from interface: `Context`
      Return the application available flag for this Context.
      Specified by:
        `getAvailable` in interface `Context`

    - #### getCharsetMapper

          @Deprecated
          public CharsetMapper getCharsetMapper()

      Deprecated.
      Description copied from interface: `Context`
      Return the Locale to character set mapper for this Context.
      Specified by:
        `getCharsetMapper` in interface `Context`

    - #### setCharsetMapper

          @Deprecated
          public void setCharsetMapper(CharsetMapper mapper)

      Deprecated.
      Description copied from interface: `Context`
      Set the Locale to character set mapper for this Context.
      Specified by:
        `setCharsetMapper` in interface `Context`
      Parameters:
        `mapper` - The new mapper

    - #### getCharset

          public String getCharset(Locale locale)

      Description copied from interface: `Context`
      Obtain the character set name to use with the given Locale. Note that different Contexts may have different mappings of Locale to character set.
      Specified by:
        `getCharset` in interface `Context`

    - #### getConfigured

          public boolean getConfigured()

      Description copied from interface: `Context`
      Return the "correctly configured" flag for this Context.
      Specified by:
        `getConfigured` in interface `Context`

    - #### setConfigured

          public void setConfigured(boolean configured)

      Description copied from interface: `Context`
      Set the "correctly configured" flag for this Context. This can be set to false by startup listeners that detect a fatal configuration error to avoid the application from being made available.
      Specified by:
        `setConfigured` in interface `Context`
      Parameters:
        `configured` - The new correctly configured flag

    - #### getCookies

          public boolean getCookies()

      Description copied from interface: `Context`
      Return the "use cookies for session ids" flag.
      Specified by:
        `getCookies` in interface `Context`

    - #### setCookies

          public void setCookies(boolean cookies)

      Description copied from interface: `Context`
      Set the "use cookies for session ids" flag.
      Specified by:
        `setCookies` in interface `Context`
      Parameters:
        `cookies` - The new flag

    - #### getSessionCookieName

          public String getSessionCookieName()

      Description copied from interface: `Context`
      Gets the name to use for session cookies. Overrides any setting that may be specified by the application.
      Specified by:
        `getSessionCookieName` in interface `Context`
      Returns:
        The value of the default session cookie name or null if not specified

    - #### setSessionCookieName

          public void setSessionCookieName(String sessionCookieName)

      Description copied from interface: `Context`
      Sets the name to use for session cookies. Overrides any setting that may be specified by the application.
      Specified by:
        `setSessionCookieName` in interface `Context`
      Parameters:
        `sessionCookieName` - The name to use

    - #### getUseHttpOnly

          public boolean getUseHttpOnly()

      Description copied from interface: `Context`
      Gets the value of the use HttpOnly cookies for session cookies flag.
      Specified by:
        `getUseHttpOnly` in interface `Context`
      Returns:
        `true` if the HttpOnly flag should be set on session cookies

    - #### setUseHttpOnly

          public void setUseHttpOnly(boolean useHttpOnly)

      Description copied from interface: `Context`
      Sets the use HttpOnly cookies for session cookies flag.
      Specified by:
        `setUseHttpOnly` in interface `Context`
      Parameters:
        `useHttpOnly` - Set to `true` to use HttpOnly cookies for session cookies

    - #### getSessionCookieDomain

          public String getSessionCookieDomain()

      Description copied from interface: `Context`
      Gets the domain to use for session cookies. Overrides any setting that may be specified by the application.
      Specified by:
        `getSessionCookieDomain` in interface `Context`
      Returns:
        The value of the default session cookie domain or null if not specified

    - #### setSessionCookieDomain

          public void setSessionCookieDomain(String sessionCookieDomain)

      Description copied from interface: `Context`
      Sets the domain to use for session cookies. Overrides any setting that may be specified by the application.
      Specified by:
        `setSessionCookieDomain` in interface `Context`
      Parameters:
        `sessionCookieDomain` - The domain to use

    - #### getSessionCookiePath

          public String getSessionCookiePath()

      Description copied from interface: `Context`
      Gets the path to use for session cookies. Overrides any setting that may be specified by the application.
      Specified by:
        `getSessionCookiePath` in interface `Context`
      Returns:
        The value of the default session cookie path or null if not specified

    - #### setSessionCookiePath

          public void setSessionCookiePath(String sessionCookiePath)

      Description copied from interface: `Context`
      Sets the path to use for session cookies. Overrides any setting that may be specified by the application.
      Specified by:
        `setSessionCookiePath` in interface `Context`
      Parameters:
        `sessionCookiePath` - The path to use

    - #### getSessionCookiePathUsesTrailingSlash

          public boolean getSessionCookiePathUsesTrailingSlash()

      Description copied from interface: `Context`
      Is a / added to the end of the session cookie path to ensure browsers, particularly IE, don't send a session cookie for context /foo with requests intended for context /foobar.
      Specified by:
        `getSessionCookiePathUsesTrailingSlash` in interface `Context`
      Returns:
        `true` if the slash is added, otherwise `false`

    - #### setSessionCookiePathUsesTrailingSlash

          public void setSessionCookiePathUsesTrailingSlash(boolean sessionCookiePathUsesTrailingSlash)

      Description copied from interface: `Context`
      Configures if a / is added to the end of the session cookie path to ensure browsers, particularly IE, don't send a session cookie for context /foo with requests intended for context /foobar.
      Specified by:
        `setSessionCookiePathUsesTrailingSlash` in interface `Context`
      Parameters:
        `sessionCookiePathUsesTrailingSlash` - `true` if the slash is should be added, otherwise `false`

    - #### getCrossContext

          public boolean getCrossContext()

      Description copied from interface: `Context`
      Return the "allow crossing servlet contexts" flag.
      Specified by:
        `getCrossContext` in interface `Context`

    - #### setCrossContext

          public void setCrossContext(boolean crossContext)

      Description copied from interface: `Context`
      Set the "allow crossing servlet contexts" flag.
      Specified by:
        `setCrossContext` in interface `Context`
      Parameters:
        `crossContext` - The new cross contexts flag

    - #### getAltDDName

          public String getAltDDName()

      Description copied from interface: `Context`
      Return the alternate Deployment Descriptor name.
      Specified by:
        `getAltDDName` in interface `Context`

    - #### setAltDDName

          public void setAltDDName(String altDDName)

      Description copied from interface: `Context`
      Set an alternate Deployment Descriptor name.
      Specified by:
        `setAltDDName` in interface `Context`

    - #### getDisplayName

          public String getDisplayName()

      Description copied from interface: `Context`
      Return the display name of this web application.
      Specified by:
        `getDisplayName` in interface `Context`

    - #### setDisplayName

          public void setDisplayName(String displayName)

      Description copied from interface: `Context`
      Set the display name of this web application.
      Specified by:
        `setDisplayName` in interface `Context`
      Parameters:
        `displayName` - The new display name

    - #### getDistributable

          public boolean getDistributable()

      Description copied from interface: `Context`
      Return the distributable flag for this web application.
      Specified by:
        `getDistributable` in interface `Context`

    - #### setDistributable

          public void setDistributable(boolean distributable)

      Description copied from interface: `Context`
      Set the distributable flag for this web application.
      Specified by:
        `setDistributable` in interface `Context`
      Parameters:
        `distributable` - The new distributable flag

    - #### getEncodedPath

          public String getEncodedPath()

      Description copied from interface: `Context`
      Return the URL encoded context path, using UTF-8.
      Specified by:
        `getEncodedPath` in interface `Context`

    - #### getIgnoreAnnotations

          public boolean getIgnoreAnnotations()

      Description copied from interface: `Context`
      Return the boolean on the annotations parsing.
      Specified by:
        `getIgnoreAnnotations` in interface `Context`

    - #### setIgnoreAnnotations

          public void setIgnoreAnnotations(boolean ignoreAnnotations)

      Description copied from interface: `Context`
      Set the boolean on the annotations parsing for this web application.
      Specified by:
        `setIgnoreAnnotations` in interface `Context`
      Parameters:
        `ignoreAnnotations` - The boolean on the annotations parsing

    - #### getLoginConfig

          public LoginConfig getLoginConfig()

      Description copied from interface: `Context`
      Return the login configuration descriptor for this web application.
      Specified by:
        `getLoginConfig` in interface `Context`

    - #### setLoginConfig

          public void setLoginConfig(LoginConfig config)

      Description copied from interface: `Context`
      Set the login configuration descriptor for this web application.
      Specified by:
        `setLoginConfig` in interface `Context`
      Parameters:
        `config` - The new login configuration

    - #### getMapper

          public Mapper getMapper()

      Description copied from interface: `Context`
      Get the request dispatcher mapper.
      Specified by:
        `getMapper` in interface `Context`

    - #### getNamingResources

          public NamingResources getNamingResources()

      Description copied from interface: `Context`
      Return the naming resources associated with this web application.
      Specified by:
        `getNamingResources` in interface `Context`

    - #### setNamingResources

          public void setNamingResources(NamingResources namingResources)

      Description copied from interface: `Context`
      Set the naming resources for this web application.
      Specified by:
        `setNamingResources` in interface `Context`
      Parameters:
        `namingResources` - The new naming resources

    - #### getPublicId

          public String getPublicId()

      Description copied from interface: `Context`
      Return the public identifier of the deployment descriptor DTD that is currently being parsed.
      Specified by:
        `getPublicId` in interface `Context`

    - #### setPublicId

          public void setPublicId(String publicId)

      Description copied from interface: `Context`
      Set the public identifier of the deployment descriptor DTD that is currently being parsed.
      Specified by:
        `setPublicId` in interface `Context`
      Parameters:
        `publicId` - The public identifier

    - #### getReloadable

          public boolean getReloadable()

      Description copied from interface: `Context`
      Return the reloadable flag for this web application.
      Specified by:
        `getReloadable` in interface `Context`

    - #### setReloadable

          public void setReloadable(boolean reloadable)

      Description copied from interface: `Context`
      Set the reloadable flag for this web application.
      Specified by:
        `setReloadable` in interface `Context`
      Parameters:
        `reloadable` - The new reloadable flag

    - #### getOverride

          public boolean getOverride()

      Description copied from interface: `Context`
      Return the override flag for this web application.
      Specified by:
        `getOverride` in interface `Context`

    - #### setOverride

          public void setOverride(boolean override)

      Description copied from interface: `Context`
      Set the override flag for this web application.
      Specified by:
        `setOverride` in interface `Context`
      Parameters:
        `override` - The new override flag

    - #### getPrivileged

          public boolean getPrivileged()

      Description copied from interface: `Context`
      Return the privileged flag for this web application.
      Specified by:
        `getPrivileged` in interface `Context`

    - #### setPrivileged

          public void setPrivileged(boolean privileged)

      Description copied from interface: `Context`
      Set the privileged flag for this web application.
      Specified by:
        `setPrivileged` in interface `Context`
      Parameters:
        `privileged` - The new privileged flag

    - #### getServletContext

          public ServletContext getServletContext()

      Description copied from interface: `Context`
      Return the servlet context for which this Context is a facade.
      Specified by:
        `getServletContext` in interface `Context`

    - #### getSessionTimeout

          public int getSessionTimeout()

      Description copied from interface: `Context`
      Return the default session timeout (in minutes) for this web application.
      Specified by:
        `getSessionTimeout` in interface `Context`

    - #### setSessionTimeout

          public void setSessionTimeout(int timeout)

      Description copied from interface: `Context`
      Set the default session timeout (in minutes) for this web application.
      Specified by:
        `setSessionTimeout` in interface `Context`
      Parameters:
        `timeout` - The new default session timeout

    - #### getSwallowAbortedUploads

          public boolean getSwallowAbortedUploads()

      Description copied from interface: `Context`
      Returns `true` if remaining request data will be read (swallowed) even the request violates a data size constraint.
      Specified by:
        `getSwallowAbortedUploads` in interface `Context`
      Returns:
        `true` if data will be swallowed (default), `false` otherwise.

    - #### setSwallowAbortedUploads

          public void setSwallowAbortedUploads(boolean swallowAbortedUploads)

      Description copied from interface: `Context`
      Set to `false` to disable request data swallowing after an upload was aborted due to size constraints.
      Specified by:
        `setSwallowAbortedUploads` in interface `Context`
      Parameters:
        `swallowAbortedUploads` - `false` to disable swallowing, `true` otherwise (default).

    - #### getSwallowOutput

          public boolean getSwallowOutput()

      Description copied from interface: `Context`
      Return the value of the swallowOutput flag.
      Specified by:
        `getSwallowOutput` in interface `Context`

    - #### setSwallowOutput

          public void setSwallowOutput(boolean swallowOutput)

      Description copied from interface: `Context`
      Set the value of the swallowOutput flag. If set to true, the system.out and system.err will be redirected to the logger during a servlet execution.
      Specified by:
        `setSwallowOutput` in interface `Context`
      Parameters:
        `swallowOutput` - The new value

    - #### getWrapperClass

          public String getWrapperClass()

      Description copied from interface: `Context`
      Return the Java class name of the Wrapper implementation used for servlets registered in this Context.
      Specified by:
        `getWrapperClass` in interface `Context`

    - #### setWrapperClass

          public void setWrapperClass(String wrapperClass)

      Description copied from interface: `Context`
      Set the Java class name of the Wrapper implementation used for servlets registered in this Context.
      Specified by:
        `setWrapperClass` in interface `Context`
      Parameters:
        `wrapperClass` - The new wrapper class

    - #### getXmlNamespaceAware

          public boolean getXmlNamespaceAware()

      Description copied from interface: `Context`
      Will the parsing of web.xml and web-fragment.xml files for this Context be performed by a namespace aware parser?
      Specified by:
        `getXmlNamespaceAware` in interface `Context`
      Returns:
        true if namespace awareness is enabled.

    - #### setXmlNamespaceAware

          public void setXmlNamespaceAware(boolean xmlNamespaceAware)

      Description copied from interface: `Context`
      Controls whether the parsing of web.xml and web-fragment.xml files for this Context will be performed by a namespace aware parser.
      Specified by:
        `setXmlNamespaceAware` in interface `Context`
      Parameters:
        `xmlNamespaceAware` - true to enable namespace awareness

    - #### getXmlValidation

          public boolean getXmlValidation()

      Description copied from interface: `Context`
      Will the parsing of web.xml and web-fragment.xml files for this Context be performed by a validating parser?
      Specified by:
        `getXmlValidation` in interface `Context`
      Returns:
        true if validation is enabled.

    - #### setXmlValidation

          public void setXmlValidation(boolean xmlValidation)

      Description copied from interface: `Context`
      Controls whether the parsing of web.xml and web-fragment.xml files for this Context will be performed by a validating parser.
      Specified by:
        `setXmlValidation` in interface `Context`
      Parameters:
        `xmlValidation` - true to enable xml validation

    - #### setTldValidation

          public void setTldValidation(boolean tldValidation)

      Description copied from interface: `Context`
      Controls whether the parsing of *.tld files for this Context will be performed by a validating parser.
      Specified by:
        `setTldValidation` in interface `Context`
      Parameters:
        `tldValidation` - true to enable xml validation

    - #### getXmlBlockExternal

          public boolean getXmlBlockExternal()

      Description copied from interface: `Context`
      Will the parsing of web.xml, web-fragment.xml, *.tld, *.jspx, *.tagx and tagplugin.xml files for this Context block the use of external entities?
      Specified by:
        `getXmlBlockExternal` in interface `Context`
      Returns:
        true if access to external entities is blocked

    - #### setXmlBlockExternal

          public void setXmlBlockExternal(boolean xmlBlockExternal)

      Description copied from interface: `Context`
      Controls whether the parsing of web.xml, web-fragment.xml, *.tld, *.jspx, *.tagx and tagplugin.xml files for this Context will block the use of external entities.
      Specified by:
        `setXmlBlockExternal` in interface `Context`
      Parameters:
        `xmlBlockExternal` - true to block external entities

    - #### getTldValidation

          public boolean getTldValidation()

      Description copied from interface: `Context`
      Will the parsing of *.tld files for this Context be performed by a validating parser?
      Specified by:
        `getTldValidation` in interface `Context`
      Returns:
        true if validation is enabled.

    - #### getTldNamespaceAware

          public boolean getTldNamespaceAware()

      Description copied from interface: `Context`
      *.tld files are always parsed using a namespace aware parser.
      Specified by:
        `getTldNamespaceAware` in interface `Context`
      Returns:
        Always `true`

    - #### setTldNamespaceAware

          public void setTldNamespaceAware(boolean tldNamespaceAware)

      Description copied from interface: `Context`
      *.tld files are always parsed using a namespace aware parser.
      Specified by:
        `setTldNamespaceAware` in interface `Context`
      Parameters:
        `tldNamespaceAware` - ignored

    - #### getJarScanner

          public JarScanner getJarScanner()

      Description copied from interface: `Context`
      Get the Jar Scanner to be used to scan for JAR resources for this context.
      Specified by:
        `getJarScanner` in interface `Context`
      Returns:
        The Jar Scanner configured for this context.

    - #### setJarScanner

          public void setJarScanner(JarScanner jarScanner)

      Description copied from interface: `Context`
      Set the Jar Scanner to be used to scan for JAR resources for this context.
      Specified by:
        `setJarScanner` in interface `Context`
      Parameters:
        `jarScanner` - The Jar Scanner to be used for this context.

    - #### getAuthenticator

          public Authenticator getAuthenticator()

      Description copied from interface: `Context`
      Obtain the `Authenticator` that is used by this context or `null` if none is used.
      Specified by:
        `getAuthenticator` in interface `Context`

    - #### setLogEffectiveWebXml

          public void setLogEffectiveWebXml(boolean logEffectiveWebXml)

      Description copied from interface: `Context`
      Set whether or not the effective web.xml for this context should be logged on context start.
      Specified by:
        `setLogEffectiveWebXml` in interface `Context`

    - #### getLogEffectiveWebXml

          public boolean getLogEffectiveWebXml()

      Description copied from interface: `Context`
      Should the effective web.xml for this context be logged on context start?
      Specified by:
        `getLogEffectiveWebXml` in interface `Context`

    - #### addApplicationListener

          public void addApplicationListener(ApplicationListener listener)

      Description copied from interface: `Context`
      Add a new Listener class name to the set of Listeners configured for this application.

      The `ApplicationListener` class is used to pass an additional parameter that allows to differentiate listeners to Web Application added via configuration (web.xml or annotations) vs. ones added by frameworks, such as listeners declared in JSP tag libraries (TLD files) that are added by Jasper JSP Engine.

      The recommended method to call for the first use case is `Context.addApplicationListener(String)`. The recommended replacement for the second use case is to use `addListener(...)` methods in `ServletContext`.

      Specified by:
        `addApplicationListener` in interface `Context`
      Parameters:
        `listener` - Definition of a listener, including its java class name.

    - #### addApplicationListener

          public void addApplicationListener(String listener)

      Description copied from interface: `Context`
      Add a new Listener class name to the set of Listeners configured for this application.
      Specified by:
        `addApplicationListener` in interface `Context`
      Parameters:
        `listener` - Java class name of a listener class

    - #### findApplicationListeners

          public String[] findApplicationListeners()

      Description copied from interface: `Context`
      Return the set of application listener class names configured for this application.
      Specified by:
        `findApplicationListeners` in interface `Context`

    - #### removeApplicationListener

          public void removeApplicationListener(String listener)

      Description copied from interface: `Context`
      Remove the specified application listener class from the set of listeners for this application.
      Specified by:
        `removeApplicationListener` in interface `Context`
      Parameters:
        `listener` - Java class name of the listener to be removed

    - #### addApplicationParameter

          public void addApplicationParameter(ApplicationParameter parameter)

      Description copied from interface: `Context`
      Add a new application parameter for this application.
      Specified by:
        `addApplicationParameter` in interface `Context`
      Parameters:
        `parameter` - The new application parameter

    - #### findApplicationParameters

          public ApplicationParameter[] findApplicationParameters()

      Description copied from interface: `Context`
      Return the set of application parameters for this application.
      Specified by:
        `findApplicationParameters` in interface `Context`

    - #### removeApplicationParameter

          public void removeApplicationParameter(String name)

      Description copied from interface: `Context`
      Remove the application parameter with the specified name from the set for this application.
      Specified by:
        `removeApplicationParameter` in interface `Context`
      Parameters:
        `name` - Name of the application parameter to remove

    - #### addConstraint

          public void addConstraint(SecurityConstraint constraint)

      Description copied from interface: `Context`
      Add a security constraint to the set for this web application.
      Specified by:
        `addConstraint` in interface `Context`

    - #### findConstraints

          public SecurityConstraint[] findConstraints()

      Description copied from interface: `Context`
      Return the set of security constraints for this web application. If there are none, a zero-length array is returned.
      Specified by:
        `findConstraints` in interface `Context`

    - #### removeConstraint

          public void removeConstraint(SecurityConstraint constraint)

      Description copied from interface: `Context`
      Remove the specified security constraint from this web application.
      Specified by:
        `removeConstraint` in interface `Context`
      Parameters:
        `constraint` - Constraint to be removed

    - #### addErrorPage

          public void addErrorPage(ErrorPage errorPage)

      Description copied from interface: `Context`
      Add an error page for the specified error or Java exception.
      Specified by:
        `addErrorPage` in interface `Context`
      Parameters:
        `errorPage` - The error page definition to be added

    - #### findErrorPage

          public ErrorPage findErrorPage(int errorCode)

      Description copied from interface: `Context`
      Return the error page entry for the specified HTTP error code, if any; otherwise return `null`.
      Specified by:
        `findErrorPage` in interface `Context`
      Parameters:
        `errorCode` - Error code to look up

    - #### findErrorPage

          public ErrorPage findErrorPage(String exceptionType)

      Description copied from interface: `Context`
      Return the error page entry for the specified Java exception type, if any; otherwise return `null`.
      Specified by:
        `findErrorPage` in interface `Context`
      Parameters:
        `exceptionType` - Exception type to look up

    - #### findErrorPages

          public ErrorPage[] findErrorPages()

      Description copied from interface: `Context`
      Return the set of defined error pages for all specified error codes and exception types.
      Specified by:
        `findErrorPages` in interface `Context`

    - #### removeErrorPage

          public void removeErrorPage(ErrorPage errorPage)

      Description copied from interface: `Context`
      Remove the error page for the specified error code or Java language exception, if it exists; otherwise, no action is taken.
      Specified by:
        `removeErrorPage` in interface `Context`
      Parameters:
        `errorPage` - The error page definition to be removed

    - #### addFilterDef

          public void addFilterDef(FilterDef filterDef)

      Description copied from interface: `Context`
      Add a filter definition to this Context.
      Specified by:
        `addFilterDef` in interface `Context`
      Parameters:
        `filterDef` - The filter definition to be added

    - #### findFilterDef

          public FilterDef findFilterDef(String filterName)

      Description copied from interface: `Context`
      Return the filter definition for the specified filter name, if any; otherwise return `null`.
      Specified by:
        `findFilterDef` in interface `Context`
      Parameters:
        `filterName` - Filter name to look up

    - #### findFilterDefs

          public FilterDef[] findFilterDefs()

      Description copied from interface: `Context`
      Return the set of defined filters for this Context.
      Specified by:
        `findFilterDefs` in interface `Context`

    - #### removeFilterDef

          public void removeFilterDef(FilterDef filterDef)

      Description copied from interface: `Context`
      Remove the specified filter definition from this Context, if it exists; otherwise, no action is taken.
      Specified by:
        `removeFilterDef` in interface `Context`
      Parameters:
        `filterDef` - Filter definition to be removed

    - #### addFilterMap

          public void addFilterMap(FilterMap filterMap)

      Description copied from interface: `Context`
      Add a filter mapping to this Context.
      Specified by:
        `addFilterMap` in interface `Context`
      Parameters:
        `filterMap` - The filter mapping to be added

    - #### addFilterMapBefore

          public void addFilterMapBefore(FilterMap filterMap)

      Description copied from interface: `Context`
      Add a filter mapping to this Context before the mappings defined in the deployment descriptor but after any other mappings added via this method.
      Specified by:
        `addFilterMapBefore` in interface `Context`
      Parameters:
        `filterMap` - The filter mapping to be added

    - #### findFilterMaps

          public FilterMap[] findFilterMaps()

      Description copied from interface: `Context`
      Return the set of filter mappings for this Context.
      Specified by:
        `findFilterMaps` in interface `Context`

    - #### removeFilterMap

          public void removeFilterMap(FilterMap filterMap)

      Description copied from interface: `Context`
      Remove a filter mapping from this Context.
      Specified by:
        `removeFilterMap` in interface `Context`
      Parameters:
        `filterMap` - The filter mapping to be removed

    - #### addInstanceListener

          public void addInstanceListener(String listener)

      Description copied from interface: `Context`
      Add the classname of an InstanceListener to be added to each Wrapper appended to this Context.
      Specified by:
        `addInstanceListener` in interface `Context`
      Parameters:
        `listener` - Java class name of an InstanceListener class

    - #### findInstanceListeners

          public String[] findInstanceListeners()

      Description copied from interface: `Context`
      Return the set of InstanceListener classes that will be added to newly created Wrappers automatically.
      Specified by:
        `findInstanceListeners` in interface `Context`

    - #### removeInstanceListener

          public void removeInstanceListener(String listener)

      Description copied from interface: `Context`
      Remove a class name from the set of InstanceListener classes that will be added to newly created Wrappers.
      Specified by:
        `removeInstanceListener` in interface `Context`
      Parameters:
        `listener` - Class name of an InstanceListener class to be removed

    - #### addLocaleEncodingMappingParameter

          public void addLocaleEncodingMappingParameter(String locale,
                                               String encoding)

      Description copied from interface: `Context`
      Add a Locale Encoding Mapping (see Sec 5.4 of Servlet spec 2.4)
      Specified by:
        `addLocaleEncodingMappingParameter` in interface `Context`
      Parameters:
        `locale` - locale to map an encoding for
        `encoding` - encoding to be used for a give locale

    - #### addMimeMapping

          public void addMimeMapping(String extension,
                            String mimeType)

      Description copied from interface: `Context`
      Add a new MIME mapping, replacing any existing mapping for the specified extension.
      Specified by:
        `addMimeMapping` in interface `Context`
      Parameters:
        `extension` - Filename extension being mapped
        `mimeType` - Corresponding MIME type

    - #### findMimeMapping

          public String findMimeMapping(String extension)

      Description copied from interface: `Context`
      Return the MIME type to which the specified extension is mapped, if any; otherwise return `null`.
      Specified by:
        `findMimeMapping` in interface `Context`
      Parameters:
        `extension` - Extension to map to a MIME type

    - #### findMimeMappings

          public String[] findMimeMappings()

      Description copied from interface: `Context`
      Return the extensions for which MIME mappings are defined. If there are none, a zero-length array is returned.
      Specified by:
        `findMimeMappings` in interface `Context`

    - #### removeMimeMapping

          public void removeMimeMapping(String extension)

      Description copied from interface: `Context`
      Remove the MIME mapping for the specified extension, if it exists; otherwise, no action is taken.
      Specified by:
        `removeMimeMapping` in interface `Context`
      Parameters:
        `extension` - Extension to remove the mapping for

    - #### addParameter

          public void addParameter(String name,
                          String value)

      Description copied from interface: `Context`
      Add a new context initialization parameter, replacing any existing value for the specified name.
      Specified by:
        `addParameter` in interface `Context`
      Parameters:
        `name` - Name of the new parameter
        `value` - Value of the new parameter

    - #### findParameter

          public String findParameter(String name)

      Description copied from interface: `Context`
      Return the value for the specified context initialization parameter name, if any; otherwise return `null`.
      Specified by:
        `findParameter` in interface `Context`
      Parameters:
        `name` - Name of the parameter to return

    - #### findParameters

          public String[] findParameters()

      Description copied from interface: `Context`
      Return the names of all defined context initialization parameters for this Context. If no parameters are defined, a zero-length array is returned.
      Specified by:
        `findParameters` in interface `Context`

    - #### removeParameter

          public void removeParameter(String name)

      Description copied from interface: `Context`
      Remove the context initialization parameter with the specified name, if it exists; otherwise, no action is taken.
      Specified by:
        `removeParameter` in interface `Context`
      Parameters:
        `name` - Name of the parameter to remove

    - #### addRoleMapping

          public void addRoleMapping(String role,
                            String link)

      Description copied from interface: `Context`
      Add a security role reference for this web application.
      Specified by:
        `addRoleMapping` in interface `Context`
      Parameters:
        `role` - Security role used in the application
        `link` - Actual security role to check for

    - #### findRoleMapping

          public String findRoleMapping(String role)

      Description copied from interface: `Context`
      For the given security role (as used by an application), return the corresponding role name (as defined by the underlying Realm) if there is one. Otherwise, return the specified role unchanged.
      Specified by:
        `findRoleMapping` in interface `Context`
      Parameters:
        `role` - Security role to map

    - #### removeRoleMapping

          public void removeRoleMapping(String role)

      Description copied from interface: `Context`
      Remove any security role reference for the specified name
      Specified by:
        `removeRoleMapping` in interface `Context`
      Parameters:
        `role` - Security role (as used in the application) to remove

    - #### addSecurityRole

          public void addSecurityRole(String role)

      Description copied from interface: `Context`
      Add a new security role for this web application.
      Specified by:
        `addSecurityRole` in interface `Context`
      Parameters:
        `role` - New security role

    - #### findSecurityRole

          public boolean findSecurityRole(String role)

      Description copied from interface: `Context`
      Return `true` if the specified security role is defined for this application; otherwise return `false`.
      Specified by:
        `findSecurityRole` in interface `Context`
      Parameters:
        `role` - Security role to verify

    - #### findSecurityRoles

          public String[] findSecurityRoles()

      Description copied from interface: `Context`
      Return the security roles defined for this application. If none have been defined, a zero-length array is returned.
      Specified by:
        `findSecurityRoles` in interface `Context`

    - #### removeSecurityRole

          public void removeSecurityRole(String role)

      Description copied from interface: `Context`
      Remove any security role with the specified name.
      Specified by:
        `removeSecurityRole` in interface `Context`
      Parameters:
        `role` - Security role to remove

    - #### addServletMapping

          public void addServletMapping(String pattern,
                               String name)

      Description copied from interface: `Context`
      Add a new servlet mapping, replacing any existing mapping for the specified pattern.
      Specified by:
        `addServletMapping` in interface `Context`
      Parameters:
        `pattern` - URL pattern to be mapped
        `name` - Name of the corresponding servlet to execute

    - #### addServletMapping

          public void addServletMapping(String pattern,
                               String name,
                               boolean jspWildcard)

      Description copied from interface: `Context`
      Add a new servlet mapping, replacing any existing mapping for the specified pattern.
      Specified by:
        `addServletMapping` in interface `Context`
      Parameters:
        `pattern` - URL pattern to be mapped
        `name` - Name of the corresponding servlet to execute
        `jspWildcard` - true if name identifies the JspServlet and pattern contains a wildcard; false otherwise

    - #### findServletMapping

          public String findServletMapping(String pattern)

      Description copied from interface: `Context`
      Return the servlet name mapped by the specified pattern (if any); otherwise return `null`.
      Specified by:
        `findServletMapping` in interface `Context`
      Parameters:
        `pattern` - Pattern for which a mapping is requested

    - #### findServletMappings

          public String[] findServletMappings()

      Description copied from interface: `Context`
      Return the patterns of all defined servlet mappings for this Context. If no mappings are defined, a zero-length array is returned.
      Specified by:
        `findServletMappings` in interface `Context`

    - #### removeServletMapping

          public void removeServletMapping(String pattern)

      Description copied from interface: `Context`
      Remove any servlet mapping for the specified pattern, if it exists; otherwise, no action is taken.
      Specified by:
        `removeServletMapping` in interface `Context`
      Parameters:
        `pattern` - URL pattern of the mapping to remove

    - #### addWelcomeFile

          public void addWelcomeFile(String name)

      Description copied from interface: `Context`
      Add a new welcome file to the set recognized by this Context.
      Specified by:
        `addWelcomeFile` in interface `Context`
      Parameters:
        `name` - New welcome file name

    - #### findWelcomeFile

          public boolean findWelcomeFile(String name)

      Description copied from interface: `Context`
      Return `true` if the specified welcome file is defined for this Context; otherwise return `false`.
      Specified by:
        `findWelcomeFile` in interface `Context`
      Parameters:
        `name` - Welcome file to verify

    - #### findWelcomeFiles

          public String[] findWelcomeFiles()

      Description copied from interface: `Context`
      Return the set of welcome files defined for this Context. If none are defined, a zero-length array is returned.
      Specified by:
        `findWelcomeFiles` in interface `Context`

    - #### removeWelcomeFile

          public void removeWelcomeFile(String name)

      Description copied from interface: `Context`
      Remove the specified welcome file name from the list recognized by this Context.
      Specified by:
        `removeWelcomeFile` in interface `Context`
      Parameters:
        `name` - Name of the welcome file to be removed

    - #### addWrapperLifecycle

          public void addWrapperLifecycle(String listener)

      Description copied from interface: `Context`
      Add the classname of a LifecycleListener to be added to each Wrapper appended to this Context.
      Specified by:
        `addWrapperLifecycle` in interface `Context`
      Parameters:
        `listener` - Java class name of a LifecycleListener class

    - #### findWrapperLifecycles

          public String[] findWrapperLifecycles()

      Description copied from interface: `Context`
      Return the set of LifecycleListener classes that will be added to newly created Wrappers automatically.
      Specified by:
        `findWrapperLifecycles` in interface `Context`

    - #### removeWrapperLifecycle

          public void removeWrapperLifecycle(String listener)

      Description copied from interface: `Context`
      Remove a class name from the set of LifecycleListener classes that will be added to newly created Wrappers.
      Specified by:
        `removeWrapperLifecycle` in interface `Context`
      Parameters:
        `listener` - Class name of a LifecycleListener class to be removed

    - #### addWrapperListener

          public void addWrapperListener(String listener)

      Description copied from interface: `Context`
      Add the classname of a ContainerListener to be added to each Wrapper appended to this Context.
      Specified by:
        `addWrapperListener` in interface `Context`
      Parameters:
        `listener` - Java class name of a ContainerListener class

    - #### findWrapperListeners

          public String[] findWrapperListeners()

      Description copied from interface: `Context`
      Return the set of ContainerListener classes that will be added to newly created Wrappers automatically.
      Specified by:
        `findWrapperListeners` in interface `Context`

    - #### removeWrapperListener

          public void removeWrapperListener(String listener)

      Description copied from interface: `Context`
      Remove a class name from the set of ContainerListener classes that will be added to newly created Wrappers.
      Specified by:
        `removeWrapperListener` in interface `Context`
      Parameters:
        `listener` - Class name of a ContainerListener class to be removed

    - #### createWrapper

          public Wrapper createWrapper()

      Description copied from interface: `Context`
      Factory method to create and return a new Wrapper instance, of the Java implementation class appropriate for this Context implementation. The constructor of the instantiated Wrapper will have been called, but no properties will have been set.
      Specified by:
        `createWrapper` in interface `Context`

    - #### findStatusPage

          public String findStatusPage(int status)

      Description copied from interface: `Context`
      Return the context-relative URI of the error page for the specified HTTP status code, if any; otherwise return `null`.
      Specified by:
        `findStatusPage` in interface `Context`
      Parameters:
        `status` - HTTP status code to look up

    - #### findStatusPages

          public int[] findStatusPages()

      Description copied from interface: `Context`
      Return the set of HTTP status codes for which error pages have been specified. If none are specified, a zero-length array is returned.
      Specified by:
        `findStatusPages` in interface `Context`

    - #### fireRequestInitEvent

          public boolean fireRequestInitEvent(ServletRequest request)

      Description copied from interface: `Context`
      Notify all `ServletRequestListener`s that a request has started.
      Specified by:
        `fireRequestInitEvent` in interface `Context`
      Returns:
        `true` if the listeners fire successfully, else `false`

    - #### fireRequestDestroyEvent

          public boolean fireRequestDestroyEvent(ServletRequest request)

      Description copied from interface: `Context`
      Notify all `ServletRequestListener`s that a request has ended.
      Specified by:
        `fireRequestDestroyEvent` in interface `Context`
      Returns:
        `true` if the listeners fire successfully, else `false`

    - #### reload

          public void reload()

      Description copied from interface: `Context`
      Reload this web application, if reloading is supported.
      Specified by:
        `reload` in interface `Context`

    - #### getRealPath

          public String getRealPath(String path)

      Description copied from interface: `Context`
      Return the real path for a given virtual path, if possible; otherwise return `null`.
      Specified by:
        `getRealPath` in interface `Context`
      Parameters:
        `path` - The path to the desired resource

    - #### getEffectiveMajorVersion

          public int getEffectiveMajorVersion()

      Description copied from interface: `Context`
      Return the effective major version of the Servlet spec used by this context.
      Specified by:
        `getEffectiveMajorVersion` in interface `Context`

    - #### setEffectiveMajorVersion

          public void setEffectiveMajorVersion(int major)

      Description copied from interface: `Context`
      Set the effective major version of the Servlet spec used by this context.
      Specified by:
        `setEffectiveMajorVersion` in interface `Context`

    - #### getEffectiveMinorVersion

          public int getEffectiveMinorVersion()

      Description copied from interface: `Context`
      Return the effective minor version of the Servlet spec used by this context.
      Specified by:
        `getEffectiveMinorVersion` in interface `Context`

    - #### setEffectiveMinorVersion

          public void setEffectiveMinorVersion(int minor)

      Description copied from interface: `Context`
      Set the effective minor version of the Servlet spec used by this context.
      Specified by:
        `setEffectiveMinorVersion` in interface `Context`

    - #### getJspConfigDescriptor

          public JspConfigDescriptor getJspConfigDescriptor()

      Description copied from interface: `Context`
      Obtain the JSP configuration for this context.
      Specified by:
        `getJspConfigDescriptor` in interface `Context`

    - #### addResourceJarUrl

          public void addResourceJarUrl(URL url)

      Description copied from interface: `Context`
      Add a URL for a JAR that contains static resources in a META-INF/resources directory that should be included in the static resources for this context.
      Specified by:
        `addResourceJarUrl` in interface `Context`

    - #### addServletContainerInitializer

          public void addServletContainerInitializer(ServletContainerInitializer sci,
                                            Set<Class<?>> classes)

      Description copied from interface: `Context`
      Add a ServletContainerInitializer instance to this web application.
      Specified by:
        `addServletContainerInitializer` in interface `Context`
      Parameters:
        `sci` - The instance to add
        `classes` - The classes in which the initializer expressed an interest

    - #### getPaused

          public boolean getPaused()

      Description copied from interface: `Context`
      Is this Context paused whilst it is reloaded?
      Specified by:
        `getPaused` in interface `Context`

    - #### isServlet22

          public boolean isServlet22()

      Description copied from interface: `Context`
      Is this context using version 2.2 of the Servlet spec?
      Specified by:
        `isServlet22` in interface `Context`

    - #### addServletSecurity

          public Set<String> addServletSecurity(ApplicationServletRegistration registration,
                                       ServletSecurityElement servletSecurityElement)

      Description copied from interface: `Context`
      Notification that servlet security has been dynamically set in a `ServletRegistration.Dynamic`
      Specified by:
        `addServletSecurity` in interface `Context`
      Parameters:
        `registration` - servlet security was modified for
        `servletSecurityElement` - new security constraints for this servlet
      Returns:
        urls currently mapped to this registration that are already present in web.xml

    - #### setResourceOnlyServlets

          public void setResourceOnlyServlets(String resourceOnlyServlets)

      Description copied from interface: `Context`
      Sets the (comma separated) list of Servlets that expect a resource to be present. Used to ensure that welcome files associated with Servlets that expect a resource to be present are not mapped when there is no resource.
      Specified by:
        `setResourceOnlyServlets` in interface `Context`

    - #### getResourceOnlyServlets

          public String getResourceOnlyServlets()

      Description copied from interface: `Context`
      Obtains the list of Servlets that expect a resource to be present.
      Specified by:
        `getResourceOnlyServlets` in interface `Context`
      Returns:
        A comma separated list of Servlet names as used in web.xml

    - #### isResourceOnlyServlet

          public boolean isResourceOnlyServlet(String servletName)

      Description copied from interface: `Context`
      Checks the named Servlet to see if it expects a resource to be present.
      Specified by:
        `isResourceOnlyServlet` in interface `Context`
      Parameters:
        `servletName` - Name of the Servlet (as per web.xml) to check
      Returns:
        `true` if the Servlet expects a resource, otherwise `false`

    - #### getBaseName

          public String getBaseName()

      Description copied from interface: `Context`
      Return the base name to use for WARs, directories or context.xml files for this context.
      Specified by:
        `getBaseName` in interface `Context`

    - #### setFireRequestListenersOnForwards

          public void setFireRequestListenersOnForwards(boolean enable)

      Description copied from interface: `Context`
      Configure whether or not requests listeners will be fired on forwards for this Context.
      Specified by:
        `setFireRequestListenersOnForwards` in interface `Context`

    - #### getFireRequestListenersOnForwards

          public boolean getFireRequestListenersOnForwards()

      Description copied from interface: `Context`
      Determine whether or not requests listeners will be fired on forwards for this Context.
      Specified by:
        `getFireRequestListenersOnForwards` in interface `Context`

    - #### setPreemptiveAuthentication

          public void setPreemptiveAuthentication(boolean enable)

      Description copied from interface: `Context`
      Configures if a user presents authentication credentials, whether the context will process them when the request is for a non-protected resource.
      Specified by:
        `setPreemptiveAuthentication` in interface `Context`

    - #### getPreemptiveAuthentication

          public boolean getPreemptiveAuthentication()

      Description copied from interface: `Context`
      Determines if a user presents authentication credentials, will the context will process them when the request is for a non-protected resource.
      Specified by:
        `getPreemptiveAuthentication` in interface `Context`

    - #### setSendRedirectBody

          public void setSendRedirectBody(boolean enable)

      Description copied from interface: `Context`
      Configures if a response body is included when a redirect response is sent to the client.
      Specified by:
        `setSendRedirectBody` in interface `Context`

    - #### getSendRedirectBody

          public boolean getSendRedirectBody()

      Description copied from interface: `Context`
      Determines if the context is configured to include a response body as part of a redirect response.
      Specified by:
        `getSendRedirectBody` in interface `Context`

    - #### addValve

          public void addValve(Valve valve)

    - #### getInfo

          public String getInfo()

      Description copied from interface: `Container`
      Return descriptive information about this Container implementation and the corresponding version number, in the format `<description>/<version>`.
      Specified by:
        `getInfo` in interface `Container`

    - #### getMappingObject

          public Object getMappingObject()

      Description copied from interface: `Container`
      Return an object which may be utilized for mapping to this component.
      Specified by:
        `getMappingObject` in interface `Container`

    - #### addPostConstructMethod

          public void addPostConstructMethod(String clazz,
                                    String method)

      Description copied from interface: `Context`
      Add a post construct method definition for the given class, if there is an existing definition for the specified class - IllegalArgumentException will be thrown.
      Specified by:
        `addPostConstructMethod` in interface `Context`
      Parameters:
        `clazz` - Fully qualified class name
        `method` - Post construct method name

    - #### addPreDestroyMethod

          public void addPreDestroyMethod(String clazz,
                                 String method)

      Description copied from interface: `Context`
      Add a pre destroy method definition for the given class, if there is an existing definition for the specified class - IllegalArgumentException will be thrown.
      Specified by:
        `addPreDestroyMethod` in interface `Context`
      Parameters:
        `clazz` - Fully qualified class name
        `method` - Post construct method name

    - #### removePostConstructMethod

          public void removePostConstructMethod(String clazz)

      Description copied from interface: `Context`
      Removes the post construct method definition for the given class, if it exists; otherwise, no action is taken.
      Specified by:
        `removePostConstructMethod` in interface `Context`
      Parameters:
        `clazz` - Fully qualified class name

    - #### removePreDestroyMethod

          public void removePreDestroyMethod(String clazz)

      Description copied from interface: `Context`
      Removes the pre destroy method definition for the given class, if it exists; otherwise, no action is taken.
      Specified by:
        `removePreDestroyMethod` in interface `Context`
      Parameters:
        `clazz` - Fully qualified class name

    - #### findPostConstructMethod

          public String findPostConstructMethod(String clazz)

      Description copied from interface: `Context`
      Returns the method name that is specified as post construct method for the given class, if it exists; otherwise `NULL` will be returned.
      Specified by:
        `findPostConstructMethod` in interface `Context`
      Parameters:
        `clazz` - Fully qualified class name
      Returns:
        the method name that is specified as post construct method for the given class, if it exists; otherwise `NULL` will be returned.

    - #### findPreDestroyMethod

          public String findPreDestroyMethod(String clazz)

      Description copied from interface: `Context`
      Returns the method name that is specified as pre destroy method for the given class, if it exists; otherwise `NULL` will be returned.
      Specified by:
        `findPreDestroyMethod` in interface `Context`
      Parameters:
        `clazz` - Fully qualified class name
      Returns:
        the method name that is specified as pre destroy method for the given class, if it exists; otherwise `NULL` will be returned.

    - #### findPostConstructMethods

          public Map<String,String> findPostConstructMethods()

      Description copied from interface: `Context`
      Returns a map with keys - fully qualified class names of the classes that have post construct methods and the values are the corresponding method names. If there are no such classes an empty map will be returned.
      Specified by:
        `findPostConstructMethods` in interface `Context`
      Returns:
        a map with keys - fully qualified class names of the classes that have post construct methods and the values are the corresponding method names.

    - #### findPreDestroyMethods

          public Map<String,String> findPreDestroyMethods()

      Description copied from interface: `Context`
      Returns a map with keys - fully qualified class names of the classes that have pre destroy methods and the values are the corresponding method names. If there are no such classes an empty map will be returned.
      Specified by:
        `findPreDestroyMethods` in interface `Context`
      Returns:
        a map with keys - fully qualified class names of the classes that have pre destroy methods and the values are the corresponding method names.

    - #### getInstanceManager

          public InstanceManager getInstanceManager()

      Description copied from interface: `Context`
      Get the instance manager associated with this context.
      Specified by:
        `getInstanceManager` in interface `Context`

    - #### setInstanceManager

          public void setInstanceManager(InstanceManager instanceManager)

      Description copied from interface: `Context`
      Set the instance manager associated with this context.
      Specified by:
        `setInstanceManager` in interface `Context`

    - #### setContainerSciFilter

          public void setContainerSciFilter(String containerSciFilter)

      Description copied from interface: `Context`
      Sets the regular expression that specifies which container provided SCIs should be filtered out and not used for this context. Matching uses `Matcher.find()` so the regular expression only has to match a sub-string of the fully qualified class name of the container provided SCI for it to be filtered out.
      Specified by:
        `setContainerSciFilter` in interface `Context`
      Parameters:
        `containerSciFilter` - The regular expression against which the fully qualified class name of each container provided SCI should be checked

    - #### getContainerSciFilter

          public String getContainerSciFilter()

      Description copied from interface: `Context`
      Obtains the regular expression that specifies which container provided SCIs should be filtered out and not used for this context. Matching uses `Matcher.find()` so the regular expression only has to match a sub-string of the fully qualified class name of the container provided SCI for it to be filtered out.
      Specified by:
        `getContainerSciFilter` in interface `Context`
      Returns:
        The regular expression against which the fully qualified class name of each container provided SCI will be checked

    - #### setValidateClientProvidedNewSessionId

          public void setValidateClientProvidedNewSessionId(boolean validateClientProvidedNewSessionId)

      Description copied from interface: `Context`
      When a client provides the ID for a new session, should that ID be validated? The only use case for using a client provided session ID is to have a common session ID across multiple web applications. Therefore, any client provided session ID should already exist in another web application. If this check is enabled, the client provided session ID will only be used if the session ID exists in at least one other web application for the current host. Note that the following additional tests are always applied, irrespective of this setting:
      - The session ID is provided by a cookie
      - The session cookie has a path of `/`
      Specified by:
        `setValidateClientProvidedNewSessionId` in interface `Context`
      Parameters:
        `validateClientProvidedNewSessionId` - `true` if validation should be applied

    - #### getValidateClientProvidedNewSessionId

          public boolean getValidateClientProvidedNewSessionId()

      Description copied from interface: `Context`
      Will client provided session IDs be validated (see `Context.setValidateClientProvidedNewSessionId(boolean)`) before use?
      Specified by:
        `getValidateClientProvidedNewSessionId` in interface `Context`
      Returns:
        `true` if validation will be applied. Otherwise, `false`

    - #### setMapperContextRootRedirectEnabled

          public void setMapperContextRootRedirectEnabled(boolean mapperContextRootRedirectEnabled)

      Description copied from interface: `Context`
      If enabled, requests for a web application context root will be redirected (adding a trailing slash) by the Mapper. This is more efficient but has the side effect of confirming that the context path is valid.
      Specified by:
        `setMapperContextRootRedirectEnabled` in interface `Context`
      Parameters:
        `mapperContextRootRedirectEnabled` - Should the redirects be enabled?

    - #### getMapperContextRootRedirectEnabled

          public boolean getMapperContextRootRedirectEnabled()

      Description copied from interface: `Context`
      Determines if requests for a web application context root will be redirected (adding a trailing slash) by the Mapper. This is more efficient but has the side effect of confirming that the context path is valid.
      Specified by:
        `getMapperContextRootRedirectEnabled` in interface `Context`
      Returns:
        `true` if the Mapper level redirect is enabled for this Context.

    - #### setMapperDirectoryRedirectEnabled

          public void setMapperDirectoryRedirectEnabled(boolean mapperDirectoryRedirectEnabled)

      Description copied from interface: `Context`
      If enabled, requests for a directory will be redirected (adding a trailing slash) by the Mapper. This is more efficient but has the side effect of confirming that the directory is valid.
      Specified by:
        `setMapperDirectoryRedirectEnabled` in interface `Context`
      Parameters:
        `mapperDirectoryRedirectEnabled` - Should the redirects be enabled?

    - #### getMapperDirectoryRedirectEnabled

          public boolean getMapperDirectoryRedirectEnabled()

      Description copied from interface: `Context`
      Determines if requests for a directory will be redirected (adding a trailing slash) by the Mapper. This is more efficient but has the side effect of confirming that the directory is valid.
      Specified by:
        `getMapperDirectoryRedirectEnabled` in interface `Context`
      Returns:
        `true` if the Mapper level redirect is enabled for this Context.

    - #### setUseRelativeRedirects

          public void setUseRelativeRedirects(boolean useRelativeRedirects)

      Description copied from interface: `Context`
      Controls whether HTTP 1.1 and later location headers generated by a call to `HttpServletResponse.sendRedirect(String)` will use relative or absolute redirects.

      Relative redirects are more efficient but may not work with reverse proxies that change the context path. It should be noted that it is not recommended to use a reverse proxy to change the context path because of the multiple issues it creates.

      Absolute redirects should work with reverse proxies that change the context path but may cause issues with the `RemoteIpFilter` if the filter is changing the scheme and/or port.

      Specified by:
        `setUseRelativeRedirects` in interface `Context`
      Parameters:
        `useRelativeRedirects` - `true` to use relative redirects and `false` to use absolute redirects

    - #### getUseRelativeRedirects

          public boolean getUseRelativeRedirects()

      Description copied from interface: `Context`
      Will HTTP 1.1 and later location headers generated by a call to `HttpServletResponse.sendRedirect(String)` use relative or absolute redirects.
      Specified by:
        `getUseRelativeRedirects` in interface `Context`
      Returns:
        `true` if relative redirects will be used `false` if absolute redirects are used.
      See Also:
        `Context.setUseRelativeRedirects(boolean)`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.